// SLogic	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "component_led.h"
#include "common.h"

using namespace os;

ComponentLED :: ComponentLED() : Component( LoadImage( "led.png" ), LoadImage( "led.png" ), "LED", "LED" )
{
	m_ActiveLED = LoadImage( "led_active.png" );
	m_ActiveLEDDrag = LoadImage( "led_active.png" );
	m_ActiveLEDDrag->ApplyFilter( Image::F_GRAY );
	m_DeactiveLED = LoadImage( "led.png" );
	m_DeactiveLEDDrag = LoadImage( "led.png" );
	m_DeactiveLEDDrag->ApplyFilter( Image::F_GRAY );

	AddInputPin( Point( 4, 23 ), "A" );
}

ComponentLED :: ~ComponentLED()
{
}

Component* ComponentLED :: Duplicate()
{
	return new ComponentLED();
}

void ComponentLED :: ChangeInputState( String pin_name, bool state )
{
	if( state )
	{
		Component::SetImages( m_ActiveLED, m_ActiveLEDDrag );
	}
	else
	{
		Component::SetImages( m_DeactiveLED, m_DeactiveLEDDrag );
	}

	Redraw();
}
