// SLogic	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "component_not.h"
#include "common.h"

using namespace os;

ComponentNOT :: ComponentNOT() : Component( LoadImage( "not_grind.png" ), LoadImage( "not_grind.png" ), "NOT", "NOT gate" )
{
	AddInputPin( Point( 0, 23 ), "A" );
	AddOutputPin( Point( 48, 23 ), "Q" );

	SetDelay( 1 );
}

ComponentNOT :: ~ComponentNOT()
{
}

Component* ComponentNOT :: Duplicate()
{
	return new ComponentNOT();
}

bool ComponentNOT :: GetOutputState( String name )
{
	if( name == "Q" )  // Update output
	{
		printf( "NOT Pin A: %d   => Output Q: %d\n", GetPinState( "A" ), !GetPinState( "A" ) );

		return ( !GetPinState( "A" ) );
	}

	return false;
}

void ComponentNOT :: ChangeInputState( String pin_name, bool state )
{
	if( pin_name == "A" )
	{
		// Recalculate pin out
		SetPinState( "Q", GetOutputState( "Q" ) );
	}
}
