// SLogic	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __TOOL_ARROW_H_
#define __TOOL_ARROW_H_

#include "tool.h"

class ToolArrow : public Tool
{
public:
	ToolArrow();
	~ToolArrow();

	virtual void Init();
	virtual void MouseUp( CompDraw* draw, const os::Point& cPosition, uint32 nButtons );
	virtual void MouseDown( CompDraw* draw, const os::Point& cPosition, uint32 nButtons );
	virtual void MouseMove( CompDraw* draw, const os::Point& cPosition, uint32 nButtons );

private:
	bool m_bMouseDown;
	bool m_bMouseDownOverIcon;
	bool m_bDragging;
	bool m_bSelecting;
	os::Point m_cSelectStart;
	os::Point m_cLastSelectPosition;
	os::Point m_cStartDragPosition;
	os::Point m_cOldRelativePosition;
	bigtime_t m_nLastClick;

};

#endif

